// This Test Port skeleton source file was generated by the
// TTCN-3 Compiler of the TTCN-3 Test Executor version CRL 113 200/5 R3A
// for U-ERICSSON\ethgry (ethgry@HU00078339) on Fri Aug 14 21:19:06 2015

// Copyright Ericsson Telecom AB 2000-2014

// You may modify this file. Complete the body of empty functions and
// add your member functions here.

#include "PkiPort.hh"
#include "pki_layer_factory.hh"
#include "loggers.hh"

namespace LibItsPki__TestSystem {

  PkiPort::PkiPort(const char *par_port_name)
    : PkiPort_BASE(par_port_name), _cfg_params(), _layer_params(), _layer(nullptr), _time_key("PkiPort::outgoing_send") {
    // Nothing to do
  }

  PkiPort::~PkiPort()
  {
    loggers::get_instance().log(">>> PkiPort::~PkiPort");
    
    if (_layer != nullptr) {
      delete _layer;
    }
  }

  void PkiPort::set_parameter(const char* parameter_name, const char* parameter_value)
  {
    loggers::get_instance().log("PkiPort::set_parameter: %s=%s", parameter_name, parameter_value);
    _cfg_params.insert(std::pair<std::string, std::string>(std::string(parameter_name), std::string(parameter_value)));
  }

  /*void PkiPort::Handle_Fd_Event(int fd, boolean is_readable,
    boolean is_writable, boolean is_error) {}*/

  void PkiPort::Handle_Fd_Event_Error(int /*fd*/)
  {

  }

  void PkiPort::Handle_Fd_Event_Writable(int /*fd*/)
  {

  }

  void PkiPort::Handle_Fd_Event_Readable(int /*fd*/)
  {

  }

  /*void PkiPort::Handle_Timeout(double time_since_last_call) {}*/

  void PkiPort::user_map(const char* system_port)
  {
    loggers::get_instance().log(">>> PkiPort::user_map: %s", system_port);
    // Build layer stack
    params::iterator it = _cfg_params.find(std::string("params"));
    if (it != _cfg_params.end()) {
      loggers::get_instance().log("PkiPort::user_map: %s", it->second.c_str());
      // Setup parameters
      params::convert(_layer_params, it->second); // TODO This _layer_params seems to be useless
      // Create layer
      _layer = layer_stack_builder::get_instance()->create_layer_stack(it->second.c_str());
      if (static_cast<pki_layer *>(_layer) == nullptr) {
        loggers::get_instance().error("PkiPort::user_map: Invalid stack configuration: %s", it->second.c_str());
      }
      static_cast<pki_layer *>(_layer)->add_upper_port(this);
    
    } else {
      loggers::get_instance().error("PkiPort::user_map: No layers defined in configuration file");
    }
  }

  void PkiPort::user_unmap(const char* system_port)
  {
    loggers::get_instance().log(">>> PkiPort::user_unmap: %s", system_port);

    // Reset layers
    if (_layer != nullptr) {
      delete _layer;
      _layer = nullptr;
    }
  }

  void PkiPort::user_start()
  {
    loggers::get_instance().log(">>> PkiPort::user_start");

  }

  void PkiPort::user_stop()
  {
    loggers::get_instance().log(">>> PkiPort::user_stop");

  }

  void PkiPort::outgoing_send(const EtsiTs102941TypesEnrolment::InnerEcRequest& send_par)
  {
    loggers::get_instance().log_msg(">>> PkiPort::outgoing_send: payload=", send_par);
    
    float duration;
    loggers::get_instance().set_start_time(_time_key);
    params params;
    static_cast<pki_layer *>(_layer)->sendMsg(send_par, params);
    loggers::get_instance().set_stop_time(_time_key, duration);
  }

  void PkiPort::outgoing_send(const EtsiTs102941TypesEnrolment::InnerEcResponse& send_par)
  {

  }

  void PkiPort::outgoing_send(const EtsiTs102941TypesAuthorizationValidation::AuthorizationValidationRequest& send_par) {
    loggers::get_instance().log_msg(">>> PkiPort::outgoing_send: payload=", send_par);
    
    float duration;
    loggers::get_instance().set_start_time(_time_key);
    params params;
    static_cast<pki_layer *>(_layer)->sendMsg(send_par, params);
    loggers::get_instance().set_stop_time(_time_key, duration);
  }
  
  void PkiPort::outgoing_send(const EtsiTs102941TypesAuthorizationValidation::AuthorizationValidationResponse& send_par) {
  }
  
  void PkiPort::receiveMsg (const EtsiTs102941TypesEnrolment::InnerEcRequest& p_ind, const params& p_params) {
    loggers::get_instance().log_msg(">>> PkiPort::receive_msg: ", p_ind);
    // Sanity check
    if (!p_ind.is_bound()) {
      return;
    }

    incoming_message(p_ind);
  }

  void PkiPort::receiveMsg (const EtsiTs102941TypesEnrolment::InnerEcResponse& p_ind, const params& p_params) {
    loggers::get_instance().log_msg(">>> PkiPort::receive_msg: ", p_ind);
    // Sanity check
    if (!p_ind.is_bound()) {
      return;
    }

    incoming_message(p_ind);
  }
  
  void PkiPort::receiveMsg (const EtsiTs102941TypesAuthorizationValidation::AuthorizationValidationRequest& p_ind, const params& p_params) {
    loggers::get_instance().log_msg(">>> PkiPort::receive_msg: ", p_ind);
    // Sanity check
    if (!p_ind.is_bound()) {
      return;
    }

    incoming_message(p_ind);
  }

  void PkiPort::receiveMsg (const EtsiTs102941TypesAuthorizationValidation::AuthorizationValidationResponse& p_ind, const params& p_params) {
    loggers::get_instance().log_msg(">>> PkiPort::receive_msg: ", p_ind);
    // Sanity check
    if (!p_ind.is_bound()) {
      return;
    }

    incoming_message(p_ind);
  }
  
} /* end of namespace */

